// Dependencies
var Promise = require('bluebird');
var moment  = require('moment');
var request = Promise.promisifyAll(require('request'));
var geocode = require('notebook')('capicue/geocode/5.0.0');

// API endpoints
var issNowUrl  = 'http://api.open-notify.org/iss-now.json';
var issPassUrl = 'http://api.open-notify.org/iss-pass.json';
var astrosUrl  = 'http://api.open-notify.org/astros.json';;

function currentPosition() {
    return request.getAsync(issNowUrl).then(function(body) {
        return JSON.parse(body[1]).iss_position;
    });
}; 0;;

function nextPass(location) {
    return geocode.simpleLookup(location).then(function(coordinates) {
        var options = {lat: coordinates.lat, lon: coordinates.lng};
        return request.getAsync({url: issPassUrl, qs: options});
    }).then(function(passResult) {
        var timestamp = JSON.parse(passResult[1]).response[0].risetime;
        return moment.unix(timestamp).fromNow();
    });
}; 0;;

function numberInSpace() {
    return request.getAsync(astrosUrl).then(function(response) {
        return JSON.parse(response[1]).number;
    });
}; 0;;

function peopleInSpace() {
    return request.getAsync(astrosUrl).then(function(response) {
        return JSON.parse(response[1]).people;
    });
}; 0;;
module.exports = {
    currentPosition: currentPosition,
    nextPass: nextPass,
    numberInSpace: numberInSpace,
    peopleInSpace: peopleInSpace
}; 0;;
await currentPosition();;
// Change this to use your location in this example
var myLocation = "San Francisco, CA";

await nextPass(myLocation);;
await numberInSpace();;
var people = await peopleInSpace();

people.map(function(person) {
    return person.name + " (" + person.craft + ")";
});;